#ifndef _ENVIRON_H
#define _ENVIRON_H
#include "instance.h"
class Environ   // Environment
{   private:
    double max_reflect;     // Maximum reflected color
    double max_x;           // Maximum x-axis extent
    double max_y;           // Maximum y-axis extent
    double max_z;           // Maximum z-axis extent
    double min_x;           // Minimum x-axis extent
    double min_y;           // Minimum y-axis extent
    double min_z;           // Minimum z-axis extent
    Instance *pinsthd;      // Instance list pointer
    WORD num_inst;          // Number of instances
    WORD num_surf;          // Number of surfaces
    WORD num_patch;         // Number of patches
    WORD num_elem;          // Number of elements
    WORD num_vert;          // Number of vertices
    friend class Parse;
  public:
    Environ()
    { pinsthd = NULL;
      max_reflect = 0.0;
    }
     ~Environ() { DeleteEnv(); }
    double GetMaxReflect() { return max_reflect; }
    double GetMax_X() { return max_x; }
    double GetMax_Y() { return max_y; }
    double GetMax_Z() { return max_z; }
    double GetMin_X() { return min_x; }
    double GetMin_Y() { return min_y; }
    double GetMin_Z() { return min_z; }
    Instance *GetInstPtr() { return pinsthd; }
    WORD GetNumInst() { return num_inst; }
    WORD GetNumSurf() { return num_surf; }
    WORD GetNumPatch() { return num_patch; }
    WORD GetNumElem() { return num_elem; }
    WORD GetNumVert() { return num_vert; }
    void CalcExtents();
    void DeleteEnv()
    { Instance *pinst;  // Instance pointer
      Instance *pnext;  // Next instance pointer
      pinst = pinsthd;
      while (pinst != NULL)
      { pnext = pinst->GetNext();
        delete pinst;
        pinst= pnext;
      }
      pinsthd = NULL;
    }
    void SetMaxReflect( double mr ) { max_reflect = mr; }
};
#endif

