#include "../include/environ.h"  // Calculate environment extents
void Environ::CalcExtents()
{  double vx, vy, vz;    // Vertex co-ordinates
  Instance *pinst;      // Instance pointer
  Vertex3 *pvert;       // Vertex pointer
  // Initialize extents
  max_x = max_y = max_z = -MAX_VALUE;
  min_x = min_y = min_z = MAX_VALUE;
  // Walk the instance list
  pinst = pinsthd;
  while (pinst != NULL)
  {    // Walk the vertex list
    pvert = pinst->GetVertPtr();
    while (pvert != NULL)
    {       // Get vertex co-ordinates
      vx = pvert->GetPosn().GetX();
      vy = pvert->GetPosn().GetY();
      vz = pvert->GetPosn().GetZ();
      // Update x-axis extents
      if (vx > max_x)
        max_x = vx;
      if (vx < min_x)
        min_x = vx;
      // Update y-axis extents
      if (vy > max_y)
        max_y = vy;
      if (vy < min_y)
        min_y = vy;
      // Update z-axis extents
      if (vz > max_z)
        max_z = vz;
      if (vz < min_z)
        min_z = vz;
      pvert = pvert->GetNext();
    }
    pinst = pinst->GetNext();
  }
}

